/*  lv_error.h
 * 
 *  LabVIEW Error Cluster Utilities 
 *
 *  Copyright 2004-2014 Martin Henz
 *  All rights reserved.
 *
 *	E-Mail: martin.henz@mhst.de
 *	Web: http://www.mhst.de
 *
 *
 *  Redistribution and use in source and binary forms, with or without modification, 
 *  are permitted provided that the following conditions are met:
 *  
 *  * Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 *  
 *  * Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *  
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
 *  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
 *  SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 *  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
 *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 *  OF SUCH DAMAGE.
 * */

#ifndef __inc_lv_error_h
#define __inc_lv_error_h

#include "extcode.h"

//error cluster and error reporting
#ifndef __typedef_ErrC
#define __typedef_ErrC
//#pragma pack(1)
#include "lv_prolog.h"
typedef struct _STRUCT_LVERRORCLUSTER {
	LVBoolean lfStatus;
	long lCode;
	LStrHandle shSource;
} ErrC, *pErrC, **hErrC;
//#pragma pack()
#include "lv_epilog.h"
#endif

#if defined(__cplusplus) || defined(__cplusplus__)
   extern "C" {
#endif

void lv_ErrBld(LVBoolean lfStatus, long lCode, char *pszSource, pErrC pError);
void lv_ErrBldMsg(LVBoolean lfStatus, long lCode, char *pszSource, char *pszMsg, pErrC pError);
void lv_ErrBldOpt(LVBoolean lfStatus, long lCode, char *pszSource, char *pszMsg, char *pszOptMsg, pErrC pError);
void lv_ErrBuilder(LVBoolean lfStatus, long lCode, char *pszSource, char *pszMsg, char *pszOptMsg, char *pszReason, pErrC pError);
void lv_EasyErrBld(long lCode, char *pszSource, pErrC pError);
void lv_WinErrBld(long lCode, char *pszSource, pErrC pError);
void lv_WarnOrErrBld(long lCode, char *pszSource, pErrC pError);

void lv_LStrErrBld(LVBoolean *plfStatus, long lCode, LStrHandle shSource, pErrC pError);
void lv_LStrEasyErrBld(long lCode, LStrHandle shSource, pErrC pError);

#if defined(__cplusplus) || defined(__cplusplus__)
   }
#endif

#endif
